Tp::Client::ConnectionInterfaceLocationInterface Class Reference

| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Tp::Client::ConnectionInterfaceLocationInterface Class Reference
Connection proxies

`#include <TelepathyQt/Connection>`

Inherits Tp::AbstractInterface.

## Public Slots
QDBusPendingReply < Tp::ContactLocations > | GetLocations (const Tp::UIntList &contacts, int timeout=-1)
QDBusPendingReply< QVariantMap > | RequestLocation (uint contact, int timeout=-1)
QDBusPendingReply | SetLocation (const QVariantMap &location, int timeout=-1)

## Signals
void | LocationUpdated (uint contact, const QVariantMap &location)
Signals inherited from Tp::AbstractInterface
void | propertiesChanged (const QVariantMap &changedProperties, const QStringList &invalidatedProperties)

## Public Member Functions
| ConnectionInterfaceLocationInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
| ConnectionInterfaceLocationInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
| ConnectionInterfaceLocationInterface (Tp::DBusProxy *proxy)
| ConnectionInterfaceLocationInterface (const Tp::Client::ConnectionInterface &mainInterface)
| ConnectionInterfaceLocationInterface (const Tp::Client::ConnectionInterface &mainInterface, QObject *parent)
Tp::PendingVariant * | requestPropertyLocationAccessControlTypes () const
Tp::PendingVariant * | requestPropertyLocationAccessControl () const
Tp::PendingOperation * | setPropertyLocationAccessControl (Tp::RichPresenceAccessControl newValue)
Tp::PendingVariant * | requestPropertySupportedLocationFeatures () const
Tp::PendingVariantMap * | requestAllProperties () const
Public Member Functions inherited from Tp::AbstractInterface
virtual | ~AbstractInterface ()
bool | isValid () const
QString | invalidationReason () const
QString | invalidationMessage () const
void | setMonitorProperties (bool monitorProperties)
bool | isMonitoringProperties () const

## Static Public Member Functions
static QLatin1String | staticInterfaceName ()

## Protected Member Functions
virtual void | invalidate (Tp::DBusProxy *, const QString &, const QString &)
Protected Member Functions inherited from Tp::AbstractInterface
| AbstractInterface (DBusProxy *proxy, const QLatin1String &interface)
| AbstractInterface (const QString &busName, const QString &path, const QLatin1String &interface, const QDBusConnection &connection, QObject *parent)
PendingVariant * | internalRequestProperty (const QString &name) const
PendingOperation * | internalSetProperty (const QString &name, const QVariant &newValue)
PendingVariantMap * | internalRequestAllProperties () const

## Additional Inherited Members
Protected Slots inherited from Tp::AbstractInterface

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Connection.Interface.Location".

## Constructor & Destructor Documentation

Tp::Client::ConnectionInterfaceLocationInterface::ConnectionInterfaceLocationInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ConnectionInterfaceLocationInterface associated with the given object on the session bus.

Parameters

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ConnectionInterfaceLocationInterface::ConnectionInterfaceLocationInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ConnectionInterfaceLocationInterface associated with the given object on the given bus.

Parameters

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::ConnectionInterfaceLocationInterface::ConnectionInterfaceLocationInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a ConnectionInterfaceLocationInterface associated with the same object as the given proxy.

Parameters

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

Tp::Client::ConnectionInterfaceLocationInterface::ConnectionInterfaceLocationInterface | ( | const Tp::Client::ConnectionInterface & | mainInterface | ) |
| explicit

Creates a ConnectionInterfaceLocationInterface associated with the same object as the given proxy. Additionally, the created proxy will have the same parent as the given proxy.

Parameters

  mainInterface | The proxy to use.

Tp::Client::ConnectionInterfaceLocationInterface::ConnectionInterfaceLocationInterface | ( | const Tp::Client::ConnectionInterface & | mainInterface,
|  | QObject * | parent
| ) |  |

Creates a ConnectionInterfaceLocationInterface associated with the same object as the given proxy. However, a different parent object can be specified.

Parameters

  mainInterface | The proxy to use.
  parent | Passed to the parent class constructor.

## Member Function Documentation

static QLatin1String Tp::Client::ConnectionInterfaceLocationInterface::staticInterfaceName | ( |  | ) |
| inlinestatic

Returns the name of the interface "org.freedesktop.Telepathy.Connection.Interface.Location", which this class represents.

Returns
  The D-Bus interface name.

Tp::PendingVariant* Tp::Client::ConnectionInterfaceLocationInterface::requestPropertyLocationAccessControlTypes | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `LocationAccessControlTypes` of type `Tp::UIntList`.

The types of access control that are supported by this connection.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::ConnectionInterfaceLocationInterface::requestPropertyLocationAccessControl | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `LocationAccessControl` of type `Tp::RichPresenceAccessControl`.

The current access control mechanism and settings for this connection. Before publishing location for the first time, if this has not been set by a client, implementations SHOULD set it to be as restrictive as possible (an empty whitelist, if supported).

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingOperation* Tp::Client::ConnectionInterfaceLocationInterface::setPropertyLocationAccessControl | ( | Tp::RichPresenceAccessControl | newValue | ) |
| inline

Asynchronous setter for the remote object property `LocationAccessControl` of type `Tp::RichPresenceAccessControl`.

The current access control mechanism and settings for this connection. Before publishing location for the first time, if this has not been set by a client, implementations SHOULD set it to be as restrictive as possible (an empty whitelist, if supported).

Returns
  A pending operation which will emit finished when the property has been set.

Tp::PendingVariant* Tp::Client::ConnectionInterfaceLocationInterface::requestPropertySupportedLocationFeatures | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `SupportedLocationFeatures` of type `uint`.

Indicates the Location features supported by this connection. This property MAY be undefined before ConnectionInterface::Status becomes `Connected`, but MUST remain constant thereafter.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariantMap* Tp::Client::ConnectionInterfaceLocationInterface::requestAllProperties | ( |  | ) | const
| inline

Request all of the DBus properties on the interface.

Returns
  A pending variant map which will emit finished when the properties have been retrieved.

QDBusPendingReply<Tp::ContactLocations> Tp::Client::ConnectionInterfaceLocationInterface::GetLocations | ( | const Tp::UIntList & | contacts,
|  | int | timeout = `-1`
| ) |  |
| inlineslot

Begins a call to the D-Bus method `GetLocations` on the remote object.

Return the current locations of the given contacts, if they are already known. If any of the given contacts' locations are not known, request their current locations, but return immediately without waiting for a reply; if a reply with a non-empty location is later received for those contacts, the LocationUpdated() signal will be emitted for them.

This method is appropriate for "lazy" location finding, for instance displaying the location (if available) of everyone in your contact list.

For backwards compatibility, if this method is called by a client whose "interest count" for this interface, as defined by ConnectionInterface::AddClientInterest() , is zero, the Connection SHOULD behave as if AddClientInterest had been called for this interface just before that method call. Clients that do not explicitly call AddClientInterest SHOULD NOT call ConnectionInterface::RemoveClientInterest() either.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  contacts |
      The contacts whose locations should be returned or signalled.
  timeout | The timeout in milliseconds.

Returns

      The contacts&apos; locations, if already known. Contacts whose
      locations are not already known are omitted from the mapping;
      contacts known to have no location information appear in the
      mapping with an empty Location dictionary.

QDBusPendingReply<QVariantMap> Tp::Client::ConnectionInterfaceLocationInterface::RequestLocation | ( | uint | contact,
|  | int | timeout = `-1`
| ) |  |
| inlineslot

Begins a call to the D-Bus method `RequestLocation` on the remote object.

Return the current location of the given contact. If necessary, make a request to the server for up-to-date information, and wait for a reply. This method is appropriate for use in a "Contact Information..." dialog; it can be used to show progress information (while waiting for the method to return), and can distinguish between various error conditions.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  contact |
      The contact whose location should be returned.
  timeout | The timeout in milliseconds.

Returns

      The contact&apos;s location. It MAY be empty, indicating that no
      location information was found.

QDBusPendingReply Tp::Client::ConnectionInterfaceLocationInterface::SetLocation | ( | const QVariantMap & | location,
|  | int | timeout = `-1`
| ) |  |
| inlineslot

Begins a call to the D-Bus method `SetLocation` on the remote object.

Set the local user's own location.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  location |
      The location to advertise. If the user wants to obscure their exact
      location by reducing the precision or accuracy, clients MUST do
      this themselves, rather than relying on the connection manager to
      do so. Clients that interact with more than one connection SHOULD
      advertise the same reduced-accuracy location to all of them, so
      that contacts cannot obtain an undesirably accurate location by
      assuming that random errors have been added and averaging the
      locations advertised on multiple connections.
  timeout | The timeout in milliseconds.

void Tp::Client::ConnectionInterfaceLocationInterface::LocationUpdated | ( | uint | contact,
|  | const QVariantMap & | location
| ) |  |
| signal

Represents the signal `LocationUpdated` on the remote object.

Emitted when a contact's location changes or becomes known.

Parameters

  contact |
      The contact
  location |
      The contact&apos;s location, or empty to indicate that nothing is
      known about the contact&apos;s location.

void Tp::Client::ConnectionInterfaceLocationInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  |
| protectedvirtual

Reimplemented from Tp::AbstractInterface.